# switch rpm itself back to md5 file digests until the dust settles a bit
%define _source_filedigest_algorithm 0
%define _binary_filedigest_algorithm 0

%define		PYVER		2.6
%define		__python	python%{PYVER}
%define		PVER		%(echo %{PYVER} | awk -F. '{print$1$2}')
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%define rpmhome /usr/lib/rpm
%define dbprefix db

Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary:	The RPM package management system.
Name:		rpm
Version:	4.8.1
Release:	2
License:	GNU/GPL
URL:		http://www.rpm.org
Group:		System/Configuration/Packaging
Source0:	rpm-%{version}.tar.bz2
Source210: 	desktop-file.prov
Source211: 	fontconfig.prov
BuildArch:	i686
Patch0: 	rpm-4.7.90-devel-autodep.patch
Patch1: 	rpm-4.5.90-pkgconfig-path.patch
Patch2: 	rpm-4.5.90-gstreamer-provides.patch

# Patches already in upstream
Patch200: rpm-4.8.0-pythondeps-parallel.patch
Patch201: rpm-4.8.0-python-bytecompile.patch
Patch202: rpm-4.8.0-findlang-localedirs.patch
Patch203: rpm-4.8.1-eat-stdin.patch
Patch204: rpm-4.8.1-getoutput-emsg.patch

# These are not yet upstream
Patch303: rpm-4.8.0-pkgconfig-private.patch

#CCux Patches
# set CCux defaults
# w7.xzdio now default compression algo
# add disable-debug macros
# pentium3 with sse utilization is now CCux i686 standard arch
Patch70:	rpm-4.7.1-ccux.patch
# explicitly set python calls in macros to /usr/bin/python2.6
Patch75:	rpm-4.8.0-fixed-pyver26.patch

BuildRoot: 	%{_tmppath}/%{name}-buildroot
Requires(pre): 	autoconf
Requires(pre): 	automake
Requires(pre): 	libtool

BuildRequires:	zlib-devel
BuildRequires:	bzip2-devel
BuildRequires:	elfutils-devel
BuildRequires:	beecrypt-devel
BuildRequires:	readline-devel
BuildRequires:	xz-devel
BuildRequires:	python%{PVER}-devel
BuildRequires:	sqlite-devel
BuildRequires:	libtool-devel
BuildRequires:	e2fsprogs-devel
BuildRequires:	nss-devel
BuildRequires:	popt-devel
BuildRequires:	popt-static
BuildRequires:	gettext-devel
BuildRequires:	ncurses-devel
BuildRequires:	nspr-devel
BuildRequires:	file-devel
BuildRequires:	db-devel

BuildConflicts: neon-devel

Requires:	beecrypt popt >= 1.10.2 neon nss nspr
Requires:	xz

Provides:	librpm-4.4.so librpmdb-4.4.so librpmio-4.4.so librpmbuild-4.4.so

#Provides:       rpmlib(PayloadIsLzma) = 4.4.2-1
#Provides:       rpmlib(PayloadIsXz) = %{version}

Obsoletes:	%{name} <= %{version}-%{release}

%description
The RPM Package Manager (RPM) is a powerful command line driven
package management system capable of installing, uninstalling,
verifying, querying, and updating software packages. Each software
package consists of an archive of files along with information about
the package like its version, a description, etc.

%package	devel
Summary:	Development files for manipulating RPM packages.
Group:		System/Configuration/Packaging
Requires:	rpm = %{version}-%{release}
Requires:	popt >= 1.12
Obsoletes:	%{name}-devel <= %{version}-%{release}

%description	devel
This package contains the RPM C library and header files. These
development files will simplify the process of writing programs that
manipulate RPM packages and databases. These files are intended to
simplify the process of creating graphical package managers or any
other tools that need an intimate knowledge of RPM packages in order
to function.

This package should be installed if you want to develop programs that
will manipulate RPM packages and databases.

%package	build
Summary:	Scripts and executable programs used to build packages.
Group:		Development/Tools
Requires:	rpm = %{version}-%{release}
Provides:	perl(Specfile)
Obsoletes:	%{name}-build <= %{version}-%{release}

%description	build
The rpm-build package contains the scripts and executable programs
that are used to build packages using the RPM Package Manager.

%package	python
Summary:	Python bindings for apps which will manipulate RPM packages.
Group:		Development/Libraries
Requires:	rpm = %{version}-%{release}
Requires:	python%{PVER}
Requires:	elfutils >= 0.55
Provides:	%{name}-python%{PVER} = %{version}-%{release}
Obsoletes:	%{name}-python <= %{version}-%{release}
Obsoletes:	%{name}-python25 <= %{version}-%{release}

%description	python
The rpm-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by RPM Package Manager libraries.

This package should be installed if you want to develop Python
programs that will manipulate RPM packages and databases.

%package	apidocs
Summary:	API documentation for RPM libraries
Group:		Documentation
BuildRequires:	doxygen
Obsoletes:	%{name}-apidocs <= %{version}-%{release}

%description	apidocs
This package contains API documentation for developing applications
that will manipulate RPM packages and databases.

%post
if [ $1 -eq 2 ]; then
    rpm -q base-config &>/dev/null || :
fi

# XXX Detect (and remove) incompatible dbenv files during upgrade.
# XXX Removing dbenv files in %%post opens a lock race window, a tolerable
# XXX risk compared to the support issues involved with upgrading Berkeley DB.
[ -w /var/lib/rpm/__db.001 ] &&
/usr/lib/rpm/rpmdb_stat -CA -h /var/lib/rpm 2>&1 |
grep "db_stat: Program version ... doesn't match environment version" 2>&1 > /dev/null &&
        rm -f /var/lib/rpm/__db*
exit 0

%prep
# ensure playload compression algorithm to be bz2
# for compatibility reasons
%define _source_payload w9.bzdio
%define _binary_payload w9.bzdio

%setup -q
%patch1 -p1 -b .pkgconfig-path
%patch2 -p1 -b .gstreamer-prov

%patch200 -p1
%patch201 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch303 -p1

%patch70 -p1
%patch75 -p1

%build
CPPFLAGS="$CPPFLAGS `pkg-config --cflags nss`"
CFLAGS="$RPM_OPT_FLAGS"
export CPPFLAGS CFLAGS LDFLAGS
PYTHON=%{__python}
__PYTHON=%{__python}
export PYTHON __PYTHON

./configure \
--prefix=%_prefix \
--sysconfdir=%_sysconfdir \
--localstatedir=/var \
--mandir=%_mandir \
--infodir=%_infodir \
--without-selinux \
--disable-selinux \
--with-selinux=no \
--enable-posixmutexes \
--with-external-db \
--without-lua \
--enable-python
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# Save list of packages through cron
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/cron.daily
install -m 755 scripts/rpm.daily $RPM_BUILD_ROOT%_sysconfdir/cron.daily/rpm

mkdir -p $RPM_BUILD_ROOT%_sysconfdir/logrotate.d
install -m 644 scripts/rpm.log $RPM_BUILD_ROOT%_sysconfdir/logrotate.d/rpm

install -p -m 755 %{SOURCE210} %{SOURCE211} ${RPM_BUILD_ROOT}%{rpmhome}/

for dbutil in \
    archive deadlock dump load printlog \
    recover stat upgrade verify
do
    ln -s ../../bin/%{dbprefix}_${dbutil} $RPM_BUILD_ROOT/%{rpmhome}/rpmdb_${dbutil}
done
ln -s ../../bin/berkeley_%{dbprefix}_svc $RPM_BUILD_ROOT/%{rpmhome}/rpmdb_svc


mkdir -p $RPM_BUILD_ROOT%_sysconfdir/rpm

mkdir -p $RPM_BUILD_ROOT/var/spool/repackage
mkdir -p $RPM_BUILD_ROOT/var/lib/rpm
for dbi in \
        Basenames Conflictname Dirnames Group Installtid Name Packages \
        Providename Provideversion Requirename Requireversion Triggername \
        Filemd5s Pubkeys Sha1header Sigmd5 \
        __db.001 __db.002 __db.003 __db.004 __db.005 __db.006 __db.007 \
        __db.008 __db.009
do
    touch $RPM_BUILD_ROOT/var/lib/rpm/$dbi
done

%find_lang %{name}

# avoid dragging in tonne of perl libs for an unused script
chmod 0644 $RPM_BUILD_ROOT/%{rpmhome}/perldeps.pl

# compress our ChangeLog, it's fairly big...
bzip2 -9 ChangeLog

# Get rid of unpackaged files
{ cd $RPM_BUILD_ROOT
  rm -f .%{_libdir}/lib*.a
  rm -f .%{rpmhome}/{Specfile.pm,cpanflute,cpanflute2,rpmdiff,rpmdiff.cgi,sql.prov,sql.req,tcl.req,rpm.*}
  rm -rf .%{_mandir}/{fr,ko}
  rm -f .%{_libdir}/python%{PYVER}/site-packages/*.{a,la}
  rm -f .%{_libdir}/python%{PYVER}/site-packages/rpm/*.{a,la}
  rm -f .%{_libdir}/python%{PYVER}/site-packages/rpmdb/*.{a,la}
}

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc GROUPS COPYING CREDITS ChangeLog.bz2 doc/manual/[a-z]*

%{_sysconfdir}/cron.daily/rpm
%config(noreplace,missingok)    %{_sysconfdir}/logrotate.d/rpm
%dir                            %{_sysconfdir}/rpm

%attr(0755, root, root)   %dir /var/lib/rpm
%attr(0644, rpm, rpm) %verify(not md5 size mtime) %ghost %config(missingok,noreplace) /var/lib/rpm/*
%attr(0755, root, root) %dir %{rpmhome}

/bin/rpm
%{_bindir}/rpm2cpio
%{_bindir}/rpmdb
%{_bindir}/rpmsign
%{_bindir}/rpmquery
%{_bindir}/rpmverify

%{_mandir}/man8/rpm.8*
%{_mandir}/man8/rpm2cpio.8*

# XXX this places translated manuals to wrong package wrt eg rpmbuild
%lang(ja) %{_mandir}/ja/man[18]/*.[18]*
%lang(pl) %{_mandir}/pl/man[18]/*.[18]*
%lang(ru) %{_mandir}/ru/man[18]/*.[18]*
%lang(sk) %{_mandir}/sk/man[18]/*.[18]*

%{rpmhome}/macros
%{rpmhome}/rpmpopt*
%{rpmhome}/rpmrc

%{rpmhome}/rpmdb_*
#%{rpmhome}/rpm.daily
#%{rpmhome}/rpm.log
#%{rpmhome}/rpm.xinetd
%{rpmhome}/rpm2cpio.sh
%{rpmhome}/tgpg

%{rpmhome}/platform
%{_libdir}/librpm*.so.*

%files build
%defattr(-,root,root)
%{_bindir}/rpmbuild
%{_bindir}/gendiff

%{_mandir}/man1/gendiff.1*

%{rpmhome}/brp-*
%{rpmhome}/check-buildroot
%{rpmhome}/check-files
%{rpmhome}/check-prereqs
%{rpmhome}/check-rpaths*
%{rpmhome}/debugedit
%{rpmhome}/find-debuginfo.sh
%{rpmhome}/find-lang.sh
%{rpmhome}/find-provides
%{rpmhome}/find-requires
%{rpmhome}/javadeps
%{rpmhome}/mono-find-provides
%{rpmhome}/mono-find-requires
%{rpmhome}/osgideps.pl
%{rpmhome}/perldeps.pl
%{rpmhome}/libtooldeps.sh
%{rpmhome}/pkgconfigdeps.sh
%{rpmhome}/ocaml-find-provides.sh
%{rpmhome}/ocaml-find-requires.sh
%{rpmhome}/perl.prov
%{rpmhome}/perl.req
#%{rpmhome}/tcl.req
%{rpmhome}/pythondeps.sh
%{rpmhome}/rpmdeps
%{rpmhome}/config.guess
%{rpmhome}/config.sub
%{rpmhome}/mkinstalldirs
#%{rpmhome}/rpmdiff*
%{rpmhome}/desktop-file.prov
%{rpmhome}/fontconfig.prov

%{rpmhome}/macros.perl
%{rpmhome}/macros.python
%{rpmhome}/macros.php

%{_mandir}/man8/rpmbuild.8*
%{_mandir}/man8/rpmdeps.8*

%files python
%defattr(-,root,root)
%{python_sitearch}/rpm

%files devel
%defattr(-,root,root)
%{_includedir}/rpm
%{_libdir}/librp*[a-z].so
%{_libdir}/librp*[a-z].la
%{_mandir}/man8/rpmgraph.8*
%{_bindir}/rpmgraph

%{_libdir}/pkgconfig/rpm.pc

%files apidocs
%defattr(-,root,root)
%doc doc/librpm/html/*

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Aug 09 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.8.1-2
- diverse fixes
* Tue Jun 15 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.8.1-1
- Version update
* Wed Feb 10 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.8.0-1
- Version update
* Tue Dec 08 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.7.2-1
- Version update
* Wed Nov 13 2009 Christian Wasem <wasem@ccux-linux.de> 4.7.1-4
- rebuild against python26-2.6.3-1
* Wed Nov 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.7.1-3
- use march=pentium3 msse mfpmath=sse by default for i686 arch builds
 (bye-bye Pentium II)
* Thu Oct 22 2009 Christian Wasem <wasem@ccux-linux.de> 4.7.1-2
- rebuild against python25-2.5.4-3
* Wed Aug 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.7.1-1
- Version update
* Fri Jul 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.7.0-5
- repackaged with bz2 compression
- adjusted warning scriplet for correct compression method 
* Fri Jun 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.7.0-4
- added disable-debug-macros
- set all macro python calls to python2.5 
- added fixed pythondeps.sh script
* Sun May 03 2009 Christian Metzen <metzench@ccux-linux.de> 4.7.0-3
- rebuild, rpm itself should be compressed with bzip2
* Fri May 01 2009 Christian Metzen <metzench@ccux-linux.de> 4.7.0-2
- remove topdir patch, RPMBUILD dir is now in user home dir
* Sun Apr 26 2009 Christian Metzen <metzench@ccux-linux.de> 4.7.0-1
- Version update
- merged different ccux packages into one single file
- lzma / xz now nativly supported
* Sat Apr 25 2009 Christian Wasem <wasem@ccux-linux.de> 4.4.2.3-3
- build with explicit /usr/bin/python2.5 not /usr/bin/python!
* Sun May 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 4.4.2.3-2
- added Provides rpmlib(PayloadIsLzma) for clean lzma upgrade path
* Sun May 18 2008 Karsten Brockmann <arcam@ccux-linux.de> 4.4.2.3-1
- Version update
- added support for lzma compressed payloads
- default payload compression is now lzma
* Thu Jan 31 2008 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-7
- get rid of -g optflag
* Fri Nov 30 2007 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-6
- fixed nspr require, seems not to be autoresolved
* Sat Nov 24 2007 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-5
- removed rpm user / group
* Fri Nov 23 2007 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-4
- added optflags patch
* Fri Nov 23 2007 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-3
- fixed permissions for /usr/src/ccux
* Fri Nov 23 2007 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-2
- Bugfix in user addition
* Fri Nov 23 2007 Christian Metzen <metzench@ccux-linux.de> 4.4.2.2-1
- Version update, separated popd package
* Wed Sep 20 2006 Karsten Brockmann <arcam@ccux-linux.de> 4.4.2-6
- rebuilt against python 2.5
* Fri Apr 21 2006 Christian Metzen <metzench@ccux-linux.de> 4.4.2-5
- changed default compression to bz2 again, saves space, cleaned spec
* Wed Apr 12 2006 Christian Metzen <metzench@ccux-linux.de> 4.4.2-4
- fixed devel package require
* Wed Apr 12 2006 Christian Metzen <metzench@ccux-linux.de> 4.4.2-3
- fixed minor bug, aded changelog
* Wed Apr 12 2006 Christian Metzen <metzench@ccux-linux.de> 4.4.2-2
- fixed minor bug
* Wed Apr 12 2006 Christian Metzen <metzench@ccux-linux.de> 4.4.2-1
- Version update, fixed minor bug
* Wed Nov 09 2005 Christian Metzen <metzench@ccux-linux.de> 4.4.1-8
- Added more RPM Macros
* Wed Sep 14 2005 Christian Metzen <metzench@ccux-linux.de> 4.4.1-7
- Removed now obsolete Apt Patch, fixed minor Bug
* Wed Jul 20 2005 Christian Metzen <metzench@ccux-linux.de> 4.4.1-6
- Added Python Modules
* Sat Jul 09 2005 Christian Metzen <metzench@ccux-linux.de> 4.4.1-5
- removed sqllite dependecy
* Fri Jul 08 2005 Karsten Brockmkann <brockmka@rz.fh-augsburg.de> 4.4.1-4
- rebuilt against openssl 0.9.8, neon 0.25.1
* Tue Jun 28 2005 Christian Metzen <metzench@ccux-linux.de> 4.4.1-3
- Fixed minor bug
* Tue Jun 28 2005 Christian Metzen <metzench@ccux-linux.de> 4.4.1-2
- Reverted Specfile to old behaviour, removed unneccessary foreign cripple
* Thu Jun 23 2005 Andreas Roth <aroth@arsoft-online.com> 4.4.1-1
- Version Update to 4.4.1
* Thu Feb 17 2005 Christian Metzen <metzench@ccux-linux.de> 4.4-3
- Fixed Minor Bug
* Thu Feb 17 2005 Christian Metzen <metzench@ccux-linux.de> 4.4-2
- Fixed some Dependencie Bugs
* Wed Feb 16 2005 Christian Metzen <metzench@ccux-linux.de> 4.4-1
- Version Update to 4.4
* Wed Apr 14 2004 Christian Metzen <metzench@ccux-linux.de> 4.2.1-2
- Initial Release
